include "basics/pts.ma".
include "connectives.ma".
include "leibniz.ma".
include "logic.ma".
axiom bool : Type[0].
axiom true : bool.
axiom false : bool.
axiom match_bool_prop : \forall (return_:bool -> Prop). (return_ (true) ) -> (return_ (false) ) -> \forall (z:bool). return_ z.
axiom match_bool_type : \forall return_ : Type[0] . return_ -> return_ -> bool -> return_.
axiom axiom_match_bool_type_true : \forall return_. \forall (case_true:return_). \forall (case_false:return_). (equal) (return_) ((match_bool_type) (return_) case_true case_false (true) ) case_true.
definition eq_match_bool_type_true : \forall return_. \forall (case_true:return_). \forall (case_false:return_). (leibniz) (return_) ((match_bool_type) (return_) case_true case_false (true) ) case_true := \lambda return_ : Type[0]. \lambda case_true : return_. \lambda case_false : return_. ((((equal_leibniz) (return_)) ((match_bool_type) (return_) case_true case_false (true) )) (case_true)) ((((axiom_match_bool_type_true) (return_)) (case_true)) (case_false)).
axiom axiom_match_bool_type_false : \forall return_. \forall (case_true:return_). \forall (case_false:return_). (equal) (return_) ((match_bool_type) (return_) case_true case_false (false) ) case_false.
definition eq_match_bool_type_false : \forall return_. \forall (case_true:return_). \forall (case_false:return_). (leibniz) (return_) ((match_bool_type) (return_) case_true case_false (false) ) case_false := \lambda return_ : Type[0]. \lambda case_true : return_. \lambda case_false : return_. ((((equal_leibniz) (return_)) ((match_bool_type) (return_) case_true case_false (false) )) (case_false)) ((((axiom_match_bool_type_false) (return_)) (case_true)) (case_false)).
definition sym_eq_match_bool_type_true : \forall return_. \forall (case_true:return_). \forall (case_false:return_). (leibniz) (return_) case_true ((match_bool_type) (return_) case_true case_false (true) ) := \lambda return_ : Type[0]. \lambda case_true : return_. \lambda case_false : return_. ((((sym_leibniz) (return_)) ((match_bool_type) (return_) case_true case_false (true) )) (case_true)) ((((eq_match_bool_type_true) (return_)) (case_true)) (case_false)).
definition sym_eq_match_bool_type_false : \forall return_. \forall (case_true:return_). \forall (case_false:return_). (leibniz) (return_) case_false ((match_bool_type) (return_) case_true case_false (false) ) := \lambda return_ : Type[0]. \lambda case_true : return_. \lambda case_false : return_. ((((sym_leibniz) (return_)) ((match_bool_type) (return_) case_true case_false (false) )) (case_false)) ((((eq_match_bool_type_false) (return_)) (case_true)) (case_false)).
definition andb : bool -> bool -> bool := \lambda b1 : bool. \lambda b2 : bool. (match_bool_type) (bool) b2 (false)  b1.
definition andb_true_r : \forall (b1:bool). \forall (b2:bool). ((eq) (bool) ((andb)  b1 b2) (true) ) -> (eq) (bool) b2 (true)  := \lambda b1 : bool. \lambda b2 : bool. ((((match_bool_prop) (\lambda j__ : bool. ((eq) (bool) ((andb)  j__ b2) (true) ) -> (eq) (bool) b2 (true) )) ((((((sym_eq_match_bool_type_true) (bool)) (b2)) ((false) )) (\lambda x : bool. ((eq) (bool) x (true) ) -> (eq) (bool) b2 (true) )) (\lambda auto : (eq) (bool) b2 (true) . (((((((rewrite_l) (bool)) (b2)) (\lambda j__ : bool. (eq) (bool) b2 j__)) (((refl) (bool)) (b2))) ((true) )) (auto))))) ((((((sym_eq_match_bool_type_false) (bool)) (b2)) ((false) )) (\lambda x : bool. ((eq) (bool) x (true) ) -> (eq) (bool) b2 (true) )) (((((match_bool_prop) (\lambda j__ : bool. ((eq) (bool) (false)  (true) ) -> (eq) (bool) j__ (true) )) (\lambda auto : (eq) (bool) (false)  (true) . (((refl) (bool)) ((true) )))) (\lambda auto : (eq) (bool) (false)  (true) . (((((((rewrite_r) (bool)) ((true) )) (\lambda j__ : bool. (eq) (bool) j__ (true) )) (((refl) (bool)) ((true) ))) ((false) )) (auto)))) (b2)))) (b1).
